<template>
  <div class="mt-cell-date-parent">
    <div
      class="mt-cell-overlay"
      :class="{
        'mt-is-employe-vide': isEmployeDateSansDispo,
      }"
    ></div>
    <div
      class="mt-cell-date columns is-mobile "
      :class="{
        'mt-is-selected': isSelectedDateEnd || isSelectedDateStart,
        'mt-is-selected-end': isSelectedDateEnd && !isSelectedDateStart,
        'mt-is-selected-start': isSelectedDateStart && selectedDateEnd && !isSelectedDateEnd,
        'mt-is-in-selected': isInSelectedDate,
        'mt-is-not-employe': !isEmploye,
      }"
    >
      <div v-if="isSelectedDateEnd && !disableCreate" class="dropdown is-active">
        <div id="dropdown-menu" class="dropdown-menu" role="menu" @click.stop>
          <div v-if="!isEmploye" class="dropdown-content" :style="dropdownStyle1">
            <button type="button" class="mt-close" @click="close">X</button>
            <mt-message-info>Effectif disponible pour toute la période sélectionnée.</mt-message-info>

            <ul v-if="disponibilitesCompleteEntre" class="is-flex mt-xyz">
              <li v-for="(corps, index) in disponibilitesCompleteEntre.corps" :key="index" class="column">
                {{ corps.lettre }} :<b>{{ corps.count }}</b>
              </li>
            </ul>

            <nuxt-link
              :to="
                profilLink({
                  name: 'disponibilites-unite',
                  query: { 'start-date': queryStartDate, 'end-date': queryEndDate },
                })
              "
              class="mt-button-margin-bottom"
            >
              <b-button class="mt-button is-size-7 mt-button-fin" type="is-secondary" expanded>
                Disponibilités
              </b-button>
            </nuxt-link>

            <nuxt-link
              v-if="isEmployeur || isAdmin"
              :to="
                profilLink({
                  name: 'activites-creer',
                  query: { 'start-date': queryStartDate, 'end-date': queryEndDate },
                })
              "
            >
              <b-button class="mt-button is-size-7 mt-button-fin has-text-weight-semibold" type="is-primary" expanded>
                Créer une activité
              </b-button>
            </nuxt-link>
          </div>
          <div v-else class="dropdown-content popup-large" :style="dropdownStyle2">
            <button type="button" class="mt-close" @click="close">X</button>
            <form @submit.prevent="enregistrerStatusDisponibilite">
              <b-field
                v-for="(typeDisponibilite, index) in typesDisponibilites"
                :key="typeDisponibilite.id"
                class="mfield"
                :label="index ? '' : 'STATUT'"
              >
                <b-checkbox v-model="disponibiliteStatus" :true-value="typeDisponibilite.id" :false-value="null">
                  <mt-disponibilite-puce :type-disponibilite="typeDisponibilite"></mt-disponibilite-puce>
                  <span>
                    {{ typeDisponibilite.libelle }}
                  </span>
                </b-checkbox>
              </b-field>
              <b-field label="COMMENTAIRE (FACULTATIF)">
                <b-input
                  v-model="disponibiliteEmploye.commentaire"
                  :disabled="disponibiliteStatus === null"
                  type="textarea"
                  placeholder="Ajoutez un commentaire"
                  class="mt-input textarea-petit"
              /></b-field>
              <div class="columns is-centered">
                <div class="column is-narrow">
                  <b-button
                    class="mt-button mt-button-fin is-size-8 has-text-weight-semibold"
                    size="is-medium"
                    type="is-primary"
                    native-type="submit"
                    expanded
                  >
                    Enregistrer
                  </b-button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
      <div class="column mt-date-wrapper is-narrow">
        <div class="mt-date" :class="{ 'mt-is-today': cell.today }">
          {{ cell.content }}
        </div>
      </div>
      <mt-pax
        v-if="!isEmploye"
        :class="[cell.outOfScope ? 'has-text-primary-lighter' : 'has-text-primary-light']"
        :disponibilites="disponibilites"
      />
      <mt-disponibilite-employe v-else :disponibilite-employe="disponibiliteEmploye" />
    </div>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import { mapGetters } from 'vuex';
import MtPax from './pax';
import MtDisponibiliteEmploye from './disponibilite-employe';
import userMixin from '~/components/mixins/userMixin';
import MtMessageInfo from '~/components/base/message/mt-message-info';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';

export default {
  components: {
    MtDisponibilitePuce,
    MtMessageInfo,
    MtPax,
    MtDisponibiliteEmploye,
  },
  mixins: [userMixin],
  props: {
    cell: {
      type: Object,
      default: () => ({}),
    },
    events: {
      type: Array,
      default: () => [],
    },
    disponibilites: {
      type: Array,
      default: () => [],
    },
    disponibiliteEmploye: {
      type: Object,
      default: () => ({}),
    },
    selectedDateStart: {
      type: Date,
      default: () => null,
    },
    selectedDateEnd: {
      type: Date,
      default: () => null,
    },
    disableCreate: {
      type: Boolean,
      default: false,
    },
    disponibilitesCompleteEntre: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      disponibiliteStatus: null,
    };
  },
  computed: {
    isEmployeDateSansDispo() {
      if (this.isEmploye) {
        return this.disponibiliteEmploye.typeDisponibilite == null;
      }
      return false;
    },
    queryStartDate() {
      return DateTime.fromJSDate(this.selectedDateStart).toISODate();
    },
    queryEndDate() {
      return DateTime.fromJSDate(this.selectedDateEnd).toISODate();
    },
    isSelectedDateEnd() {
      return this.selectedDateEnd
        ? DateTime.fromJSDate(this.selectedDateEnd).hasSame(DateTime.fromJSDate(this.cell.startDate), 'day')
        : false;
    },
    isSelectedDateStart() {
      return this.selectedDateStart
        ? DateTime.fromJSDate(this.selectedDateStart).hasSame(DateTime.fromJSDate(this.cell.startDate), 'day')
        : false;
    },
    isInSelectedDate() {
      return (
        !this.isSelectedDateStart &&
        !this.isSelectedDateEnd &&
        !!this.selectedDateStart &&
        !!this.selectedDateEnd &&
        this.selectedDateStart < this.cell.startDate &&
        this.selectedDateEnd > this.cell.startDate
      );
    },
    ...mapGetters({
      typesDisponibilites: 'context/typesDisponibilites',
    }),
    dropdownStyle1() {
      const style = {};
      const retrait = 38 * this.cell.startDate.getDay() - 266;
      style.right = `${retrait}px`;
      if (this.cell.startDate.getDay() === 0) {
        style.right = '0px';
      }
      return style;
    },
    dropdownStyle2() {
      const style = {};
      if (this.disponibiliteEmploye.typeDisponibilite !== undefined) {
        // eslint-disable-next-line vue/no-side-effects-in-computed-properties
        this.disponibiliteStatus = this.disponibiliteEmploye.typeDisponibilite.id;
      }

      const retrait = 38 * this.cell.startDate.getDay() - 290;
      style.right = `${retrait}px`;
      if (this.cell.startDate.getDay() === 0) {
        style.right = '-24px';
      }
      return style;
    },
  },
  methods: {
    enregistrerStatusDisponibilite() {
      this.$emit('disponibilite-choisie', this.disponibiliteStatus, this.disponibiliteEmploye.commentaire);
    },
    close() {
      this.$emit('close');
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
/deep/ .textarea-petit textarea {
  min-height: 4.375rem;
}

.mt-cell-date {
  width: 100%;
  text-align: left;
  font-size: 0.875rem;
  margin: 0.5rem 0 4px;

  .column {
    padding: 0;
    line-height: 20px;
  }
  .mt-date {
    margin-left: 0.8rem;
    color: #3a3a3a;
  }
  &.mt-is-selected-start,
  &.mt-is-selected-end,
  &.mt-is-in-selected {
    margin-bottom: 2px;
  }
  .mt-date.mt-is-today,
  &.mt-is-selected .mt-date {
    width: 20px;
    background: $primary;
    border-radius: 25px;
    text-align: center;
    color: white;
  }
  &.mt-is-selected .mt-date,
  &.mt-cell-date.mt-is-selected .mt-date.mt-is-today {
    background-color: $periwinkle;
  }
  .dropdown-menu {
    min-width: unset;
    margin-left: 10px;
    border-radius: 0;
  }
  .dropdown-content {
    border-radius: 0;
    padding: 0.2rem 1.4rem 0.7rem;
    position: absolute;

    &.popup-large {
      width: 16rem;
    }
  }

  a {
    display: flex;
    white-space: nowrap;
  }
  &.mt-is-in-selected {
    border-top: 1px solid $periwinkle;
    border-bottom: 1px solid $periwinkle;
    background-color: rgba($periwinkle, 0.32);
    border-left: 1px solid #dddddd;
  }
  &.mt-is-selected-start {
    margin-left: 5px;
    border-top: 1px solid $periwinkle;
    border-bottom: 1px solid $periwinkle;
    background-color: rgba($periwinkle, 0.32);
    border-top-left-radius: 10px;
    border-bottom-left-radius: 10px;
    width: calc(100% - 5px);
    .mt-date {
      margin: 0;
    }
  }
  &.mt-is-selected-end {
    .mt-date-wrapper {
      border-top: 1px solid $periwinkle;
      border-bottom: 1px solid $periwinkle;
      background-color: rgba($periwinkle, 0.32);
      border-top-right-radius: 10px;
      border-bottom-right-radius: 10px;
      border-left: 1px solid #dddddd;
    }
  }

  form {
    /deep/ .control-label {
      display: inline-flex;
    }
  }
}
.vuecal__cell--out-of-scope {
  .mt-cell-date {
    .mt-date {
      color: $brown-grey;
    }
    &.mt-is-selected {
      .mt-date {
        color: $white;
      }
    }
  }
}
.mt-cell-date-parent {
  width: 100%;
}
.mt-cell-overlay {
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;

  &.mt-is-employe-vide {
    background-color: rgba($pale-grey, 0.2);
  }
}
.mfield {
  margin-bottom: 0.5rem !important;
}

.vuecal__cell:nth-child(n + 22) .dropdown-content {
  bottom: 30px;
}

/deep/ .mt-info {
  color: $black;
  align-items: baseline;
}
.mt-xyz {
  align-items: center;
  justify-content: center;
  margin: 0.75rem 0;
  cursor: default;

  li {
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 1rem;

    b {
      font-weight: bold;
      font-size: 1rem;
      padding: 0 0.25em;
    }
  }
}
.mt-button-margin-bottom {
  margin-bottom: 0.8em;
}
.mt-close {
  font-size: 0;
  position: absolute;
  top: 1rem;
  right: 1rem;
  height: 20px;
  width: 20px;
  border-style: none;
  background-color: transparent;
  cursor: pointer;
  display: flex;
  align-items: center;
  justify-content: center;
  border-radius: 50%;

  &:hover {
    background-color: rgba(0, 0, 0, 0.25);
  }

  &:after,
  &:before {
    content: '';
    height: 14px;
    width: 2px;
    background-color: #808080;
    position: absolute;
  }
  &:after {
    transform: rotate(45deg);
  }
  &:before {
    transform: rotate(-45deg);
  }
}
</style>
